// LaunchDlg.cpp : implementation file
//

#include "stdafx.h"
#include "TAgent.h"
#include "LaunchDlg.h"
#include "TAgentDoc.h"
#include "Way.h"
#include "Set.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CLaunchDlg dialog


CLaunchDlg::CLaunchDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CLaunchDlg::IDD, pParent)
{
	m_pView = NULL;
	//{{AFX_DATA_INIT(CLaunchDlg)
	m_bClearSelection = FALSE;
	//}}AFX_DATA_INIT
}

CLaunchDlg::CLaunchDlg(CTAgentView *pView){  //  Modeless Constructor
	m_bClearSelection = FALSE;
	m_pView = pView;
}

BOOL CLaunchDlg::Create(){

	return CDialog::Create(CLaunchDlg::IDD);
}

void CLaunchDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CLaunchDlg)
	DDX_Check(pDX, IDC_CLEAR_SELECTION, m_bClearSelection);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CLaunchDlg, CDialog)
	//{{AFX_MSG_MAP(CLaunchDlg)
	ON_BN_CLICKED(IDC_SELECT, OnSelect)
	ON_LBN_DBLCLK(IDC_LIST_OF_AVAILABLE_CITIES, OnDblclkListOfAvailableCities)
	ON_BN_CLICKED(IDC_DESELECT, OnDeselect)
	ON_LBN_DBLCLK(IDC_LIST_OF_CITIES_TO_VISIT, OnDblclkListOfCitiesToVisit)
	ON_CBN_SELCHANGE(IDC_FIRST_CITY, OnSelchangeFirstCity)
	ON_BN_CLICKED(IDC_CLEAR_SELECTION, OnClearSelection)
	ON_LBN_SELCHANGE(IDC_LIST_OF_AVAILABLE_CITIES, OnSelchangeListOfAvailableCities)
	ON_LBN_SELCHANGE(IDC_LIST_OF_CITIES_TO_VISIT, OnSelchangeListOfCitiesToVisit)
	ON_WM_CLOSE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CLaunchDlg Initialization
BOOL CLaunchDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: Add extra initialization here
	CListBox *AvailCities = (CListBox *) GetDlgItem(IDC_LIST_OF_AVAILABLE_CITIES);
	CListBox *CitiesToVisit = (CListBox *) GetDlgItem(IDC_LIST_OF_CITIES_TO_VISIT);
	CComboBox *FirstCityBox = (CComboBox *) GetDlgItem(IDC_FIRST_CITY);
	CComboBox *LastCityBox = (CComboBox *) GetDlgItem(IDC_LAST_CITY);
	CTAgentDoc *pDoc = m_pView->GetDocument();
	int i;

	TRACE("CLaunchDlg::OnInitDialog is running !\nAvailCities content = %d\nCitiesToVisit content = %d\n",AvailCities->GetCount(), CitiesToVisit->GetCount());
	AvailCities->ResetContent();
	CitiesToVisit->ResetContent();
	FirstCityBox->ResetContent();
	LastCityBox->ResetContent();

	if(m_bClearSelection)
	   for(i = 0; i < pDoc->MapHeader.NumberOfCities; i++)
		   pDoc->Selected[i] = FALSE;

	for(i = 0; i < pDoc->MapHeader.NumberOfCities; i++){
		if(pDoc->Selected[i]){
		   CitiesToVisit->AddString(pDoc->Cities[i].Name);
		   FirstCityBox->AddString(pDoc->Cities[i].Name);
		   LastCityBox->AddString(pDoc->Cities[i].Name);
		}
		else
		{
		   AvailCities->AddString(pDoc->Cities[i].Name);
		}
	}

	DisableWinodwControls();
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CLaunchDlg::SetListBoxesHScroll(){
	CListBox *AvailCities = (CListBox *) GetDlgItem(IDC_LIST_OF_AVAILABLE_CITIES);
	CListBox *CitiesToVisit = (CListBox *) GetDlgItem(IDC_LIST_OF_CITIES_TO_VISIT);
	CSize Size;
	char CityName[NAMELENGTH + 1];
	int i, MaxLength = 0;
	CDC *dc = AvailCities->GetDC();
	for(i = 0; i < AvailCities->GetCount(); i++){  //  Setting width for AvailCities List
		AvailCities->GetText(i, CityName);
		Size = dc->GetTextExtent(CityName, strlen(CityName));
		if(Size.cx > MaxLength)
		   MaxLength = Size.cx;
	}   //  End of for(i...  Loop
	ReleaseDC(dc);
	AvailCities->SendMessage(LB_SETHORIZONTALEXTENT, MaxLength, 0);

	MaxLength = 0;
	dc = CitiesToVisit->GetDC();
	for(i = 0; i < CitiesToVisit->GetCount(); i++){  //  Setting width for CitiesToVisit List
		CitiesToVisit->GetText(i, CityName);
		Size = dc->GetTextExtent(CityName, strlen(CityName));
		if(Size.cx > MaxLength)
		   MaxLength = Size.cx;
	}   //  End of for(i...  Loop
	ReleaseDC(dc);
	CitiesToVisit->SendMessage(LB_SETHORIZONTALEXTENT, MaxLength, 0);

	//  Combo Box Scrolleng:   ///  Test Why Does Not Works  ///////////////////////////
//	CComboBox *StartCity = (CComboBox *)  GetDlgItem(IDC_FIRST_CITY);
//	CComboBox *LastCity = (CComboBox *)  GetDlgItem(IDC_LAST_CITY);
//	MaxLength = 0;
//	dc = StartCity->GetDC();
//	for(i = 0; i < StartCity->GetCount(); i++){  //  Setting width for StartCity List
//		Size.cx = StartCity->GetLBText(i, CityName);
//		Size = dc->GetTextExtent(CityName, strlen(CityName));
//		if(Size.cx > MaxLength)
//		   MaxLength = Size.cx;
//	}   //  End of for(i...  Loop
//	ReleaseDC(dc);
//	StartCity->SetHorizontalExtent(MaxLength);
//	StartCity->SendMessage(CB_SETHORIZONTALEXTENT, MaxLength, 0);
//
//	MaxLength = 0;
//	dc = LastCity->GetDC();
//	for(i = 0; i < LastCity->GetCount(); i++){  //  Setting width for LastCity List
//		Size.cx = LastCity->GetLBText(i, CityName);
//		Size = dc->GetTextExtent(CityName, strlen(CityName));
//		if(Size.cx > MaxLength)
//		   MaxLength = Size.cx;
//	}   //  End of for(i...  Loop
//	ReleaseDC(dc);
//	LastCity->SetHorizontalExtent(MaxLength);
//	LastCity->SendMessage(CB_SETHORIZONTALEXTENT, MaxLength, 0);
////////////////////////////////////////////////////////////////////////////////////////

}								//  End of SetListBoxesHScroll Function

void CLaunchDlg::DisableWinodwControls(){
	BOOL CTRLEnable;
	CListBox *AvailCities = (CListBox *) GetDlgItem(IDC_LIST_OF_AVAILABLE_CITIES);
	CListBox *CitiesToVisit = (CListBox *) GetDlgItem(IDC_LIST_OF_CITIES_TO_VISIT);
	CComboBox *FirstCityBox = (CComboBox *) GetDlgItem(IDC_FIRST_CITY);
	CComboBox *LastCityBox = (CComboBox *) GetDlgItem(IDC_LAST_CITY);

//  Disable Dialog controls if needed
	if(AvailCities->GetSelCount())
	   CTRLEnable = TRUE;
	   else CTRLEnable = FALSE;
	GetDlgItem(IDC_SELECT)->EnableWindow(CTRLEnable);

	if(CitiesToVisit->GetSelCount())
	   CTRLEnable = TRUE;
	   else CTRLEnable = FALSE;
	GetDlgItem(IDC_DESELECT)->EnableWindow(CTRLEnable);

	if(AvailCities->GetCount())
	   CTRLEnable = TRUE;
	   else CTRLEnable = FALSE;
	AvailCities->EnableWindow(CTRLEnable);

	if(CitiesToVisit->GetCount())
	   CTRLEnable = TRUE;
	   else CTRLEnable = FALSE;
	CitiesToVisit->EnableWindow(CTRLEnable);
	FirstCityBox->EnableWindow(CTRLEnable);
	LastCityBox->EnableWindow(CTRLEnable);
}								//  End of DisableWinodwControls Function
/////////////////////////////////////////////////////////////////////////////
// CLaunchDlg message handlers

void CLaunchDlg::OnCancel() 
{
	// TODO: Add extra cleanup here
	if(m_pView != NULL){
	   m_pView->PostMessage(WM_CANCEL_LAUNCH,IDCANCEL);		  //  Modeless Case
	   }
	   else CDialog::OnCancel();						      //  Modal case
}

void CLaunchDlg::OnOK() 
{
	// TODO: Add extra validation here
	if(m_pView != NULL){
	   CString Str, StrFirstCity, StrLastCity;
	   long CityIndex;
	   CListBox *AvailCities = (CListBox *) GetDlgItem(IDC_LIST_OF_AVAILABLE_CITIES);
	   CListBox *CitiesToVisit = (CListBox *) GetDlgItem(IDC_LIST_OF_CITIES_TO_VISIT);
	   CComboBox *StartCity = (CComboBox *)  GetDlgItem(IDC_FIRST_CITY);
	   CComboBox *LastCity = (CComboBox *)  GetDlgItem(IDC_LAST_CITY);
	   CTAgentDoc *pDoc = m_pView->GetDocument();
	   int AvailCount, SelectedCount, i;
	   CWay *SearchDef;
	   
	   Str.Empty();
	   StrFirstCity.Empty();
	   StrLastCity.Empty();

	   SelectedCount = CitiesToVisit->GetCount();
	   if((SelectedCount < 3) || (SelectedCount == LB_ERR))
		  Str.Format("The list of Cities To Visit must contain at least 3 cities!\n");

	   
	   if((StartCity->GetCurSel()) == CB_ERR)
		  Str += "First City to visit has to be choosen!\n";

	   if((LastCity->GetCurSel()) == CB_ERR)
		  Str += "Last City to visit has to be choosen!\n";
	   TRACE("Number of Cities Selected: %d\n", SelectedCount);	   
	   if(Str.IsEmpty()){	  
		  StartCity->GetLBText(StartCity->GetCurSel(), StrFirstCity);
		  LastCity->GetLBText(LastCity->GetCurSel(), StrLastCity);
		  SearchDef = new CWay(pDoc->GetCityIndex(StrFirstCity)
							  ,pDoc->GetCityIndex(StrLastCity)
							  ,SelectedCount, FALSE);

		  for(i = 0; i < SelectedCount; i++){	//  SelectedCount contains number of selected cities
			  Str.Empty();
			  CitiesToVisit->GetText(i, Str);
			  CityIndex = pDoc->GetCityIndex(Str);
			  pDoc->Selected[CityIndex] = TRUE;
			  TRACE("%d Selected (Not Added): %ld\n", i, CityIndex);
			  if(SearchDef->GetFirstCity() != CityIndex){  //  Avoid adding first city with to prevent overflow in NextCity Index.
				 SearchDef->AddCityToPath(CityIndex);			   //  Retrieve index of City to Visit
				 TRACE("%d Adding to Selection: %ld\n", i, pDoc->GetCityIndex(Str));
			  }
		  }
		  AvailCount = AvailCities->GetCount();
		  for(i = 0; i < AvailCount; i++){					   //  AvailCount contains number of selected cities
			  Str.Empty();
			  AvailCities->GetText(i, Str);
			  pDoc->Selected[pDoc->GetCityIndex(Str)] = FALSE;
		  }
		  UpdateData(TRUE);
		  m_pView->PostMessage(WM_LAUNCH_SEARCH,IDOK,(long) SearchDef);		   //  Modeless Case, No Error
	   }													   //  End if(Str.IsEmpty() 
		  else AfxMessageBox(Str, MB_ICONEXCLAMATION);		   //  An Error occured
	   }
	else CDialog::OnOK();									   //  Modal case
}

void CLaunchDlg::OnSelect() 
{
	// TODO: Add your control notification handler code here
	int nCities = 0;

	CListBox *AvailCities = (CListBox *) GetDlgItem(IDC_LIST_OF_AVAILABLE_CITIES);
	nCities = AvailCities->GetSelCount();
	if(nCities){
	   int *pnCities = new int[nCities];
	   char CityName[NAMELENGTH + 1];
	   CListBox *CitiesToVisit = (CListBox *) GetDlgItem(IDC_LIST_OF_CITIES_TO_VISIT);
	   CComboBox *FirstCityBox = (CComboBox *) GetDlgItem(IDC_FIRST_CITY);
	   CComboBox *LastCityBox = (CComboBox *) GetDlgItem(IDC_LAST_CITY);
	   AvailCities->GetSelItems(nCities, pnCities);
	   for(int i = 0; i < nCities; i++){   //  Move Selections to Cities To Visit List
		   AvailCities->GetText(pnCities[i], CityName);
		   CitiesToVisit->AddString(CityName);
		   //  The Two Combo-box objects MUST contain same Items ALL TIME
		   FirstCityBox->AddString(CityName);
		   LastCityBox->AddString(CityName);
	   }								   //  End of for(int i = 0  Loop...
	   for(i = 0; i < nCities; i++)		   //  Delete Seleted Cities from Avail List
		   AvailCities->DeleteString(pnCities[i]-i);
	   delete[] pnCities;				   //  Release Memory Allocation
	   SetListBoxesHScroll();
	   DisableWinodwControls();
	   }								   //  End of if(nCities)...
}										   //  End of OnSelect() Message Handler

void CLaunchDlg::OnDblclkListOfAvailableCities() 
{
	// TODO: Add your control notification handler code here
	OnSelect();
}

void CLaunchDlg::OnDeselect() 
{
	// TODO: Add your control notification handler code here
	int nCities = 0;
	CListBox *CitiesToVisit = (CListBox *) GetDlgItem(IDC_LIST_OF_CITIES_TO_VISIT);

	nCities = CitiesToVisit->GetSelCount();
	if(nCities){
	   int *pnCities = new int[nCities];
	   char CityName[NAMELENGTH + 1];
	   CListBox *AvailCities = (CListBox *) GetDlgItem(IDC_LIST_OF_AVAILABLE_CITIES);
	   CComboBox *FirstCityBox = (CComboBox *) GetDlgItem(IDC_FIRST_CITY);
	   CComboBox *LastCityBox = (CComboBox *) GetDlgItem(IDC_LAST_CITY);

	   CitiesToVisit->GetSelItems(nCities, pnCities);
	   for(int i = 0; i < nCities; i++){   //  Move Selections to Cities To Visit List
		   CitiesToVisit->GetText(pnCities[i], CityName);
		   AvailCities->AddString(CityName);
	   }								   //  End of for(int i = 0  Loop...

	   int CityToDelete;
	   for(i = 0; i < nCities; i++){	                //  Delete Seleted Cities from Avail List
		   CitiesToVisit->GetText(pnCities[i]-i, CityName);	       //  Get Name of City to remove
		   CityToDelete = FirstCityBox->FindString(-1, CityName);  //  Get City Index
		   if(CityToDelete != LB_ERR){							   //  Remove from Combo-Boxes
			  FirstCityBox->DeleteString(CityToDelete);
			  LastCityBox->DeleteString(CityToDelete);
		   }

		   CitiesToVisit->DeleteString(pnCities[i]-i);             //  Remove from List
	   }								   //  End of for(i = 0... Loop
	   delete[] pnCities;				   //  Release Memory Allocation
	   SetListBoxesHScroll();
	   if(!CitiesToVisit->GetCount()){     //  Clear Combo Boxes Selections
		  FirstCityBox->Clear();
		  LastCityBox->Clear();		  
	   }
	   DisableWinodwControls();
	   }								   //  End of if(nCities).
}										   //  End of OnDeselect() Message Handler

void CLaunchDlg::OnDblclkListOfCitiesToVisit() 
{
	// TODO: Add your control notification handler code here
	OnDeselect();
}

void CLaunchDlg::OnSelchangeFirstCity() 
{
	// TODO: Add your control notification handler code here
	CComboBox *StartCity = (CComboBox *)  GetDlgItem(IDC_FIRST_CITY);
	CComboBox *LastCity = (CComboBox *)  GetDlgItem(IDC_LAST_CITY);

	if((LastCity->GetCurSel()) == CB_ERR)
	   LastCity->SetCurSel(StartCity->GetCurSel());
}

void CLaunchDlg::OnClearSelection() 
{
	// TODO: Add your control notification handler code here

	CButton *ClearSelection = (CButton *) GetDlgItem(IDC_CLEAR_SELECTION);

	if(ClearSelection->GetCheck()){
	   int nCities = 0;
	   CListBox *CitiesToVisit = (CListBox *) GetDlgItem(IDC_LIST_OF_CITIES_TO_VISIT);

	   nCities = CitiesToVisit->GetCount();
	   if(nCities){
	      char CityName[NAMELENGTH + 1];
	      CListBox *AvailCities = (CListBox *) GetDlgItem(IDC_LIST_OF_AVAILABLE_CITIES);
	      CComboBox *FirstCityBox = (CComboBox *) GetDlgItem(IDC_FIRST_CITY);
	      CComboBox *LastCityBox = (CComboBox *) GetDlgItem(IDC_LAST_CITY);

	      for(int i = 0; i < nCities; i++){   //  Move all to Cities To Visit List
		      CitiesToVisit->GetText(i, CityName);
		      AvailCities->AddString(CityName);
		  }								   //  End of for(int i = 0  Loop...

	      CitiesToVisit->ResetContent();
	      FirstCityBox->ResetContent();
	      LastCityBox->ResetContent();
		  SetListBoxesHScroll();
	      DisableWinodwControls();
	   }								   //  End of if(nCities)...
	}									   //  End of if(m_bClearSelection)...
}

void CLaunchDlg::OnSelchangeListOfAvailableCities() 
{
	// TODO: Add your control notification handler code here
	DisableWinodwControls();
}

void CLaunchDlg::OnSelchangeListOfCitiesToVisit() 
{
	// TODO: Add your control notification handler code here
	DisableWinodwControls();
}

void CLaunchDlg::OnClose() 
{
	// TODO: Add your message handler code here and/or call default
	if(m_pView != NULL)
	   OnCancel();					 //  Modless case - Call OnCancel to close Launch Dialog..
	else CDialog::OnClose();         //  Modal case
}
