// TAgentDoc.cpp : implementation of the CTAgentDoc class
//

#include "stdafx.h"
#include "TAgent.h"
#include "TAgentDoc.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CTAgentDoc

IMPLEMENT_DYNCREATE(CTAgentDoc, CDocument)

BEGIN_MESSAGE_MAP(CTAgentDoc, CDocument)
	//{{AFX_MSG_MAP(CTAgentDoc)
		// NOTE - the ClassWizard will add and remove mapping macros here.
		//    DO NOT EDIT what you see in these blocks of generated code!
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTAgentDoc construction/destruction

CTAgentDoc::CTAgentDoc()
{
	// TODO: add one-time construction code here
	Cities = NULL;
	DistTable = NULL;
	Selected = NULL;
	m_ReadFile = TRUE;
}

CTAgentDoc::~CTAgentDoc()
{
	if(Selected)
	   delete [] Selected;
	if(DistTable)
	   delete [] DistTable;
	if(Cities)
	   delete [] Cities;
}

BOOL CTAgentDoc::OnNewDocument()
{
	if (!CDocument::OnNewDocument())
		return FALSE;

	// TODO: add reinitialization code here
	// (SDI documents will reuse this document)
	if(m_ReadFile){								//  Read Map File just one time.
	   FILE *fp;
	   int i,j;
	   char FileName[_MAX_PATH];
	   long Temp;
	   GetModuleFileName(AfxGetInstanceHandle(), FileName, _MAX_PATH);
	   for(i = strlen(FileName); FileName[i] != '\\'; i--);
	   strcpy(&FileName[i+1], MAP_FILE);

	   if((fp = fopen(FileName, "rb")) == NULL){
		  strcat(FileName, " - File NOT Found.");
	      AfxMessageBox(FileName);
		  exit(1);
	   }

	   //  START - Reading Map File, First read APPFILEHEADER
	   fread(&AppHeader, sizeof(APPFILEHEADER), 1, fp);	//  Get AppHeader

	   //  Testing Validity of File:
	   if(!strstr(AppHeader.Vertion,"TAV")){
		  fclose(fp);
		  strcat(FileName, " - File is NOT in TAgent Format.");
	      AfxMessageBox(FileName);
		  exit(1);
	   }

	   Temp = (AppHeader.Vertion[3]-'0')*10 + (AppHeader.Vertion[5]-'0');
	   switch(Temp){
		 case 10:{
				   fread(&MapHeader, sizeof(MAPFILEHEADER), 1, fp);	//  Get MapHeader
				   Cities = new io_CityData[MapHeader.NumberOfCities];
				   DistTable = new long[MapHeader.NumberOfCities*MapHeader.NumberOfCities];
				   Selected = new BOOL[MapHeader.NumberOfCities*MapHeader.NumberOfCities];
				   fread(Cities, sizeof(io_CityData), MapHeader.NumberOfCities, fp);
				   for(i = 0; i < MapHeader.NumberOfCities; i++){	//  Get Distances between cities
					   SetDistance(i, i, 0);
					   Selected[i] = FALSE;
					   for(j = i + 1; j < MapHeader.NumberOfCities; j++){
						   fread(&Temp, sizeof(long), 1, fp);
						   SetDistance(i, j, Temp);
						   SetDistance(j, i, Temp);
					   }
				   }
			        break;
				 }			//  End of case 10

		 default: {
					fclose(fp);
					strcat(FileName, " - File is a TAgent ");
					strcat(FileName, AppHeader.Vertion);
					AfxMessageBox(FileName);
					exit(1);
					break;
				  }
	   }					//  End of switch(Temp) statement

	   fclose(fp);
	   //  END -  Reading Map File, Done only Once.
	   m_ReadFile = FALSE;
	}

	return TRUE;
}
/////////////////////////////////////////////////////////////////////////////
// CTAgentDoc Functions
long CTAgentDoc::GetCityIndex(class CString &Str){
  char *NameToFind = Str.GetBuffer(NAMELENGTH);

  for(long i = 0; i < MapHeader.NumberOfCities; i++)
	  if(!strcmp(Cities[i].Name, NameToFind))
		 return i;

  return -1;
}

long CTAgentDoc::GetCityIndex(char *Str){
  for(long i = 0; i < MapHeader.NumberOfCities; i++)
	  if(!strcmp(Cities[i].Name, Str))
		 return i;

  return -1;
}

/////////////////////////////////////////////////////////////////////////////
// CTAgentDoc serialization

void CTAgentDoc::Serialize(CArchive& ar)
{
	if (ar.IsStoring())
	{
		// TODO: add storing code here
	}
	else
	{
		// TODO: add loading code here
	}
}

/////////////////////////////////////////////////////////////////////////////
// CTAgentDoc diagnostics

#ifdef _DEBUG
void CTAgentDoc::AssertValid() const
{
	CDocument::AssertValid();
}

void CTAgentDoc::Dump(CDumpContext& dc) const
{
	CDocument::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CTAgentDoc commands
