// TAgentDoc.h : interface of the CTAgentDoc class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_TAGENTDOC_H__8F4660BA_F4DF_11D1_AFB2_00A0C95713C2__INCLUDED_)
#define AFX_TAGENTDOC_H__8F4660BA_F4DF_11D1_AFB2_00A0C95713C2__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#define VERLENGTH 6
#define FT_MAP 0
#define FT_SEARCH 1
#define FT_SOLUTION 2

#define MESURE_MILES 0
#define MESURE_KM 1

#define MAP_FILE "USAMap.TAS"

typedef struct tagio_CityData{				//  Used to read/write City Data from Input File.
	char Name[NAMELENGTH+1];
	POINT Cord;
} io_CityData;

typedef struct tagAPPFILEHEADER{		   //  Used to Hold Application File Header
	char Vertion[VERLENGTH+1];			   /*  Do NOT change Length of String  */
	char FileType;
} APPFILEHEADER;						   //  End - tagMAPFILEHEADER struct

typedef struct tagMAPFILEHEADER{		   //  Used to Hold Map File Header
	char MapName[NAMELENGTH+1];			   /*  Not Longer than NAMELENGTH  */
	long Mesure;
	ULONG LowImprove;
	ULONG HighImprove;
	long NumberOfCities;
} MAPFILEHEADER;						   //  End - tagMAPFILEHEADER struct

//	File Header Definision for Search:
typedef struct tagSREARCHFILEHEADER{	   //  Used to Hold search File Header
	char MapName[NAMELENGTH+1];			   /*  Not Longer than NAMELENGTH  */
	long FirstCity;
	long LastCity;
	long NumberOfCities;				   //  Number of Cities to Visit
	long BestSolSum;						   //  Best Solution that was Found so far
	int  StackTop;						   //  Number of Stack Entries to load + 1
	int  Minutes;						   //  Search Time information
	int  Seconds;
	int  TCounter;
} SREARCHFILEHEADER;

class CTAgentDoc : public CDocument
{
protected: // create from serialization only
	CTAgentDoc();
	DECLARE_DYNCREATE(CTAgentDoc)

// Attributes
public:
	APPFILEHEADER AppHeader;
	MAPFILEHEADER MapHeader;
	io_CityData *Cities;				   //  Pointer to cities array.
	BOOL *Selected;						   //  Pointer to array that keeps selection
	long *DistTable;					   //  Pointer to Distance table
	void SetDistance(int i, int j, long Value) { DistTable[(j*MapHeader.NumberOfCities) + i] = Value;; }
	long GetDistance(int i, int j) { return DistTable[(j*MapHeader.NumberOfCities) + i]; }
	long GetCityIndex(class CString &Str);
	long GetCityIndex(char *Str);

private:
	BOOL m_ReadFile;

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CTAgentDoc)
	public:
	virtual BOOL OnNewDocument();
	virtual void Serialize(CArchive& ar);
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CTAgentDoc();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
protected:
	//{{AFX_MSG(CTAgentDoc)
		// NOTE - the ClassWizard will add and remove member functions here.
		//    DO NOT EDIT what you see in these blocks of generated code !
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_TAGENTDOC_H__8F4660BA_F4DF_11D1_AFB2_00A0C95713C2__INCLUDED_)
