// TAgentView.h : interface of the CTAgentView class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_TAGENTVIEW_H__8F4660BC_F4DF_11D1_AFB2_00A0C95713C2__INCLUDED_)
#define AFX_TAGENTVIEW_H__8F4660BC_F4DF_11D1_AFB2_00A0C95713C2__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

class CRunDlg;
class CLaunchDlg;
class CSolutionDlg;
class CWaitingSolutions;

#include "TAgentDoc.h"

#define MAX_THREADS 4
#define ARNG_HORIZONTAL 1
#define ARNG_VERTICAL 2
#define ARNG_USER 3
#define MAX_SOLUTIONS 40
#define SEARCH_FROM_FILE 5

class CTAgentView : public CScrollView
{
protected: // create from serialization only
	CTAgentView();
	DECLARE_DYNCREATE(CTAgentView)

// Attributes
public:
	CTAgentDoc* GetDocument();

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CTAgentView)
	public:
	virtual void OnDraw(CDC* pDC);  // overridden to draw this view
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	protected:
	virtual void OnInitialUpdate(); // called first time after construct
	virtual BOOL OnPreparePrinting(CPrintInfo* pInfo);
	virtual void OnBeginPrinting(CDC* pDC, CPrintInfo* pInfo);
	virtual void OnEndPrinting(CDC* pDC, CPrintInfo* pInfo);
	virtual void OnPrint(CDC* pDC, CPrintInfo* pInfo);
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CTAgentView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

public:
//  Functions
	UINT GetSearchToHandle(UINT SearchState);
	int GetNumberOfSolutions();
	int GetMaxSolutions() { return m_MaxSolutions; }

private:
	void SetSolutionSizeAndPosition(CSolutionDlg *SDlg, BOOL SolutionFromList);
	void PostSolutionsFromList();
	void CompressSolutions();
	CRunDlg *m_pRunDlg[MAX_THREADS];
	CSolutionDlg *m_pSolutionDlg[MAX_SOLUTIONS];
	CSolutionDlg *m_pDisplayedSolution;
	CSolutionDlg *m_pPrintedSolution;
	CPtrList m_SolutionsList;
	CLaunchDlg *m_pLaunchDlg;
	CWaitingSolutions *m_pWaitingMessageBox;
	int OldXLocation[MAX_THREADS];
	int OldYLocation[MAX_THREADS];
	int OldXLaunch, OldYLaunch;
	int m_MaxSolutions;
	int m_DlgWidth, m_TextHeight;
	BYTE m_nWinArrange;
	BOOL m_bReArrange;

	CDC *m_pdcMapMemeory;									//  Used to display Resource-Based
	CBitmap *m_pMapBitmap;									//  Bitmap
	CSize m_MapTopLeft, m_MapSizeSource, m_MapSizeDest;

	CString FileName;
protected:
	
// Generated message map functions
protected:
	//{{AFX_MSG(CTAgentView)
	afx_msg void OnFileNew();
	afx_msg void OnSearchDeleteDelete1();
	afx_msg void OnUpdateSearchDeleteDelete1(CCmdUI* pCmdUI);
	afx_msg void OnSearchDeleteDelete2();
	afx_msg void OnUpdateSearchDeleteDelete2(CCmdUI* pCmdUI);
	afx_msg void OnSearchDeleteDelete3();
	afx_msg void OnUpdateSearchDeleteDelete3(CCmdUI* pCmdUI);
	afx_msg void OnSearchDeleteDelete4();
	afx_msg void OnUpdateSearchDeleteDelete4(CCmdUI* pCmdUI);
	afx_msg void OnSearchDeleteDeleteall();
	afx_msg void OnUpdateSearchDeleteDeleteall(CCmdUI* pCmdUI);
	afx_msg void OnSearchResumeResume1();
	afx_msg void OnUpdateSearchResumeResume1(CCmdUI* pCmdUI);
	afx_msg void OnSearchResumeResume2();
	afx_msg void OnUpdateSearchResumeResume2(CCmdUI* pCmdUI);
	afx_msg void OnSearchResumeResume3();
	afx_msg void OnUpdateSearchResumeResume3(CCmdUI* pCmdUI);
	afx_msg void OnSearchResumeResume4();
	afx_msg void OnUpdateSearchResumeResume4(CCmdUI* pCmdUI);
	afx_msg void OnSearchResumeResumeall();
	afx_msg void OnUpdateSearchResumeResumeall(CCmdUI* pCmdUI);
	afx_msg void OnSearchSuspendSuspend1();
	afx_msg void OnUpdateSearchSuspendSuspend1(CCmdUI* pCmdUI);
	afx_msg void OnSearchSuspendSuspend2();
	afx_msg void OnUpdateSearchSuspendSuspend2(CCmdUI* pCmdUI);
	afx_msg void OnSearchSuspendSuspend3();
	afx_msg void OnUpdateSearchSuspendSuspend3(CCmdUI* pCmdUI);
	afx_msg void OnSearchSuspendSuspend4();
	afx_msg void OnUpdateSearchSuspendSuspend4(CCmdUI* pCmdUI);
	afx_msg void OnSearchSuspendSuspendall();
	afx_msg void OnUpdateSearchSuspendSuspendall(CCmdUI* pCmdUI);
	afx_msg void OnViewHorizontal();
	afx_msg void OnUpdateViewHorizontal(CCmdUI* pCmdUI);
	afx_msg void OnViewVertical();
	afx_msg void OnUpdateViewVertical(CCmdUI* pCmdUI);
	afx_msg void OnViewUser();
	afx_msg void OnUpdateViewUser(CCmdUI* pCmdUI);
	afx_msg void OnUpdateFileOpen(CCmdUI* pCmdUI);
	afx_msg void OnSolutions10();
	afx_msg void OnUpdateSolutions10(CCmdUI* pCmdUI);
	afx_msg void OnSolutions20();
	afx_msg void OnUpdateSolutions20(CCmdUI* pCmdUI);
	afx_msg void OnSolutions30();
	afx_msg void OnUpdateSolutions30(CCmdUI* pCmdUI);
	afx_msg void OnSolutions40();
	afx_msg void OnUpdateSolutions40(CCmdUI* pCmdUI);
	afx_msg void OnSolutionsArrangesolutions();
	afx_msg void OnUpdateSolutionsArrangesolutions(CCmdUI* pCmdUI);
	afx_msg void OnUpdateFileNew(CCmdUI* pCmdUI);
	afx_msg void OnSolutionsCloseall();
	afx_msg void OnUpdateSolutionsCloseall(CCmdUI* pCmdUI);
	afx_msg void OnUpdateAppAbout(CCmdUI* pCmdUI);
	afx_msg void OnFileOpen();
	afx_msg void OnSearchRestartRestart1();
	afx_msg void OnUpdateSearchRestartRestart1(CCmdUI* pCmdUI);
	afx_msg void OnSearchRestartRestart2();
	afx_msg void OnUpdateSearchRestartRestart2(CCmdUI* pCmdUI);
	afx_msg void OnSearchRestartRestart3();
	afx_msg void OnUpdateSearchRestartRestart3(CCmdUI* pCmdUI);
	afx_msg void OnSearchRestartRestart4();
	afx_msg void OnUpdateSearchRestartRestart4(CCmdUI* pCmdUI);
	afx_msg void OnSearchRestartRestartall();
	afx_msg void OnUpdateSearchRestartRestartall(CCmdUI* pCmdUI);
	afx_msg void OnViewCleanmap();
	afx_msg void OnUpdateViewCleanmap(CCmdUI* pCmdUI);
	afx_msg void OnDestroy();
	afx_msg void OnSolutionsPostsolutions();
	afx_msg void OnUpdateSolutionsPostsolutions(CCmdUI* pCmdUI);
	//}}AFX_MSG
	afx_msg LRESULT OnDeleteSearch(WPARAM wParam, LPARAM lParam);
	afx_msg LRESULT OnLaunchSearch(WPARAM wParam, LPARAM lParam);
	afx_msg LRESULT OnCancelLaunch(WPARAM wParam, LPARAM lParam);
	afx_msg LRESULT OnCloseSolution(WPARAM wParam, LPARAM lParam);
	afx_msg LRESULT OnDisplaySolution(WPARAM wParam, LPARAM lParam);
	afx_msg LRESULT OnSolutionPrint(WPARAM wParam, LPARAM lParam);
	afx_msg LRESULT OnSolutionReady(WPARAM wParam, LPARAM lParam);
	afx_msg LRESULT OnWaitingSolutionsClose(WPARAM wParam, LPARAM lParam);
	afx_msg LRESULT OnSetMaxSolutions(WPARAM wParam, LPARAM lParam);
	DECLARE_MESSAGE_MAP()
};

#ifndef _DEBUG  // debug version in TAgentView.cpp
inline CTAgentDoc* CTAgentView::GetDocument()
   { return (CTAgentDoc*)m_pDocument; }
#endif

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_TAGENTVIEW_H__8F4660BC_F4DF_11D1_AFB2_00A0C95713C2__INCLUDED_)
