#include "StdAfx.h"
#include "Way.h"

/////////////////////////////////////////////////////////////////////////
//  START - WAYTYPE structure Support
//  Way.Path contains the list of Cities to Visit. The first City to Visit
//  will be equal to Way.FirstCity Memeber.
//  Path will NOT include a copy of LastCity member variable
CWay::CWay(){
	Path = NULL;
	FirstCity = -1;
	LastCity = -1;
	NumberOfCities = 0;		   //  Number of Cities to Visit
	NextCity = -1;
	strcpy(strTime, "InVld");
	Optimal = FALSE;
	Sum = 0;
	TRACE("Created CWay %p NumberOfCities = %ld NextCity = %ld, Sum = %ld\n", this, NumberOfCities,  NextCity, Sum);
}

CWay::CWay(long FCity, long LCity,long NumOfCities, BOOL Opt){	//  Constructor
	NumberOfCities = NumOfCities;						//  Number of Cities to Visit	
	Path = new long[NumberOfCities];
	Path[0] = FCity;
	FirstCity = FCity;
	LastCity = LCity;
	NextCity = 0;
	strcpy(strTime, "InVld");
	Optimal = Opt;
	Sum = 0;
	TRACE("Created CWay %p NumberOfCities = %ld NextCity = %ld, Sum = %ld\n", this, NumberOfCities,  NextCity, Sum);
}

CWay::CWay(const CWay &other){							//  Copy Construcotr
	FirstCity = other.FirstCity;
	LastCity = other.LastCity;
	NumberOfCities = other.NumberOfCities;
	NextCity = other.NextCity;
	strcpy(strTime, other.strTime);
	Optimal = other.Optimal;
	Sum = other.Sum;
	TRACE("Created CWay %p NumberOfCities = %ld NextCity = %ld, Sum = %ld\n", this, NumberOfCities,  NextCity, Sum);
	
	Path = new long[NumberOfCities];
	memcpy(Path, other.Path, other.NumberOfCities * sizeof(long));
}														//  End of Copy Constructor

CWay &CWay::operator=(const CWay &other){				//  operator=
   if(this == &other)
	   return *this;

	if(NumberOfCities != other.NumberOfCities){
	   delete [] Path;
	   NumberOfCities = other.NumberOfCities;
	   Path = new long[NumberOfCities];
	   }

	FirstCity = other.FirstCity;
	LastCity = other.LastCity;
	NextCity = other.NextCity;
	strcpy(strTime, other.strTime);
	Optimal = other.Optimal;
	Sum = other.Sum;

	memcpy(Path, other.Path, NumberOfCities * sizeof(long));

	return *this;
}														//  End of operator=

CWay::~CWay(){
	TRACE("Deleted CWay %p NumberOfCities = %ld NextCity = %ld, Sum = %ld\n", this, NumberOfCities,  NextCity, Sum);
	delete [] Path;
}

void CWay::GetSolutionTitle(char *TitleBuffer, CTAgentDoc *pDoc){
	if(FirstCity == LastCity)
	   sprintf(TitleBuffer, "Roundtrip: %s, %d cities", pDoc->Cities[FirstCity].Name, NumberOfCities);
	   else sprintf(TitleBuffer, "From: %s  to  %s", pDoc->Cities[FirstCity].Name, pDoc->Cities[LastCity].Name);
	if(Optimal)
	   strcat(TitleBuffer, " (Optimal)");
}
//  END - WAYTYPE structure Support
/////////////////////////////////////////////////////////////////////////