#include "StdAfx.h"
#include "TAgentDoc.h"

#if !defined( _WAY_H_ )

#define _WAY_H_

class CWay{

public:
	CWay();
	CWay(long FCity, long LCity, long NumOfCities, BOOL Opt);	//  Constructor
	CWay(const CWay &other);						//  Copy Constructor
	~CWay();										//  Destructor

	long GetCity(long Index) const { return Path[Index]; };
	long GetNextCity() const { return NextCity; };
	void SetNextCity(long Value) { NextCity = Value; };
	long GetNumberOfCities() const { return NumberOfCities; };
	long GetFirstCity() const { return FirstCity; };
	long GetLastCity() const { return LastCity; };
	ULONG GetSum() const { return Sum; };
	BOOL IsOptimal() const { return Optimal; };
	void SetOptimal(BOOL Value) { Optimal = Value; };
	long *GetPath() const { return Path; };
	void SetSum(long Value) { Sum = (ULONG) Value; };
	void SetCity(long Index, long Value) { Path[Index] = Value; };
	char *GetstrTime() { return strTime; };
	void AddToSum(long Value) { Sum += Value; };
	void AddCityToPath(long Value) { NextCity++; Path[NextCity] = Value; };
	void GetSolutionTitle(char *TitleBuffer, CTAgentDoc *pDoc);
	CWay &operator=(const CWay &other);
	int operator==(const CWay &other) const { return Sum - other.Sum; };
	int operator<(const CWay &other) const{ return (Sum < other.Sum) ? TRUE : FALSE; };

private:
	long *Path;
	long FirstCity;
	long LastCity;
	long NumberOfCities;		   //  Number of Cities to Visit
	long NextCity;
	char strTime[6];
	BOOL Optimal;
	ULONG Sum;
};
#endif  //  _WAY_H_